"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _propTypes = require("prop-types");

var _react = _interopRequireWildcard(require("react"));

var _reduxEasy = require("./redux-easy");

var getName = function getName(index) {
  return 'cb' + index;
};
/**
 * This component renders a set of checkboxes.
 * The `list` prop specifies the text and Redux state path
 * for each checkbox.
 * Specify a `className` prop to enable styling the checkboxes.
 */


var Checkboxes = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Checkboxes, _Component);

  function Checkboxes() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Checkboxes);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Checkboxes)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (text, event) {
      var _this$props = _this.props,
          action = _this$props.action,
          list = _this$props.list;

      var _list$find = list.find(function (obj) {
        return obj.text === text;
      }),
          path = _list$find.path;

      var value = event.target.checked;
      if (path) (0, _reduxEasy.dispatchSet)(path, value);
      if (action) (0, _reduxEasy.dispatch)(action, {
        path: path,
        value: value
      });
    });
    return _this;
  }

  (0, _createClass2["default"])(Checkboxes, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          list = _this$props2.list,
          values = _this$props2.values;
      var extraProps = {};
      var testId = this.props['data-testid'];
      var checkboxes = list.map(function (obj, index) {
        var text = obj.text,
            path = obj.path;
        var checked = Boolean(values ? values[index] : (0, _reduxEasy.getPath)(path));
        var name = getName(index);
        if (testId) extraProps['data-testid'] = testId + '-' + name;
        return _react["default"].createElement("div", {
          key: name
        }, _react["default"].createElement("input", (0, _extends2["default"])({
          className: name,
          checked: checked,
          id: name,
          onChange: function onChange(e) {
            return _this2.handleChange(text, e);
          },
          type: "checkbox"
        }, extraProps)), _react["default"].createElement("label", {
          htmlFor: name
        }, text));
      });
      return _react["default"].createElement("div", {
        className: 'checkboxes ' + className
      }, checkboxes);
    }
  }]);
  return Checkboxes;
}(_react.Component);

(0, _defineProperty2["default"])(Checkboxes, "propTypes", {
  action: _propTypes.string,
  className: _propTypes.string,
  'data-testid': _propTypes.string,
  list: (0, _propTypes.arrayOf)((0, _propTypes.shape)({
    text: _propTypes.string.isRequired,
    path: _propTypes.string
  })).isRequired,
  values: (0, _propTypes.arrayOf)(_propTypes.bool).isRequired
});

var _default = (0, _reduxEasy.watch)(Checkboxes);

exports["default"] = _default;