"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _propTypes = require("prop-types");

var _react = _interopRequireWildcard(require("react"));

var _reduxEasy = require("./redux-easy");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Input = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Input, _Component);

  function Input() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Input);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Input)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "ref", null);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (event) {
      var _event$target = event.target,
          checked = _event$target.checked,
          value = _event$target.value;
      var _this$props = _this.props,
          action = _this$props.action,
          onChange = _this$props.onChange,
          path = _this$props.path,
          type = _this$props.type;
      var v = value;

      if (type === 'checkbox') {
        v = checked;
      } else if (type === 'number' || type === 'range') {
        if (value.length) v = Number(value);
      }

      if (path) (0, _reduxEasy.dispatchSet)(path, v);
      if (action) (0, _reduxEasy.dispatch)(action, {
        path: path,
        value: v
      });
      if (onChange) onChange(event);
    });
    return _this;
  }

  (0, _createClass2["default"])(Input, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          autoFocus = _this$props2.autoFocus,
          onEnter = _this$props2.onEnter,
          path = _this$props2.path,
          type = _this$props2.type;
      var value = this.props.value;
      if (!value) value = (0, _reduxEasy.getPath)(path);
      var isCheckbox = type === 'checkbox';
      if (value === undefined) value = isCheckbox ? false : '';
      var propName = isCheckbox ? 'checked' : 'value';

      var inputProps = _objectSpread({
        autoFocus: autoFocus,
        type: 'text'
      }, this.props, (0, _defineProperty2["default"])({}, propName, value));

      delete inputProps.dispatch;

      if (onEnter) {
        inputProps.onKeyPress = function (event) {
          if (event.key === 'Enter') onEnter();
        };

        delete inputProps.onEnter;
      }

      return _react["default"].createElement("input", (0, _extends2["default"])({}, inputProps, {
        onChange: this.handleChange,
        ref: function ref(input) {
          return _this2.ref = input;
        }
      }));
    }
  }]);
  return Input;
}(_react.Component);

(0, _defineProperty2["default"])(Input, "propTypes", {
  action: _propTypes.string,
  // action to be dispatched on change
  autoFocus: _propTypes.bool,
  max: _propTypes.number,
  min: _propTypes.number,
  onChange: _propTypes.func,
  // called on every change to value
  onEnter: _propTypes.func,
  // called if user presses enter key
  path: _propTypes.string,
  // state path that is updated
  type: _propTypes.string,
  // type of the HTML input
  // optional current value (obtained from state at path if not specified)
  value: (0, _propTypes.oneOfType)([_propTypes.string, _propTypes.number, _propTypes.bool])
});

var _default = (0, _reduxEasy.watch)(Input);

exports["default"] = _default;