"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _propTypes = require("prop-types");

var _react = _interopRequireWildcard(require("react"));

var _reduxEasy = require("./redux-easy");

/**
 * This component renders a set of radio buttons.
 * The `list` prop specifies the text and value
 * for each radio button.
 * The `path` prop specifies the Redux state path
 * where the value will be stored.
 * Specify a `className` prop to enable styling the radio-buttons.
 */
var RadioButtons = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(RadioButtons, _Component);

  function RadioButtons() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, RadioButtons);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(RadioButtons)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChange", function (event) {
      var _this$props = _this.props,
          action = _this$props.action,
          path = _this$props.path;
      var value = event.target.value;
      if (path) (0, _reduxEasy.dispatchSet)(path, value);
      if (action) (0, _reduxEasy.dispatch)(action, {
        path: path,
        value: value
      });
    });
    return _this;
  }

  (0, _createClass2["default"])(RadioButtons, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          list = _this$props2.list,
          path = _this$props2.path;
      var extraProps = {};
      var testId = this.props['data-testid'];
      var value = this.props.value;
      if (!value) value = (0, _reduxEasy.getPath)(path);
      var radioButtons = list.map(function (obj) {
        if (testId) extraProps['data-testid'] = testId + '-' + obj.value;
        return _react["default"].createElement("div", {
          key: obj.value
        }, _react["default"].createElement("input", (0, _extends2["default"])({
          checked: obj.value === value,
          className: obj.value,
          name: path,
          onChange: _this2.handleChange,
          type: "radio",
          value: obj.value
        }, extraProps)), _react["default"].createElement("label", null, obj.text));
      });
      return _react["default"].createElement("div", {
        className: 'radio-buttons ' + className
      }, radioButtons);
    }
  }]);
  return RadioButtons;
}(_react.Component);

(0, _defineProperty2["default"])(RadioButtons, "propTypes", {
  action: _propTypes.string,
  className: _propTypes.string,
  'data-testid': _propTypes.string,
  list: (0, _propTypes.arrayOf)((0, _propTypes.shape)({
    text: _propTypes.string.isRequired,
    value: _propTypes.string
  })).isRequired,
  path: _propTypes.string,
  value: _propTypes.string
});

var _default = (0, _reduxEasy.watch)(RadioButtons);

exports["default"] = _default;